package CS561A3.Farris;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.lang.Math;

public class game {
	

	static String algorithm = "minmax";
	static int boardSize = 10;
	static int pieceToConnect = 5;
	static int depthOfSearch = 5;
	static boolean gameType = true;  //True human vs. computer
	static String outFile = null;
	static List<move> moves = new ArrayList<move>();
	static int numNodes = 0;
	public static HashMap<int[][],List<Board>> gameTree = new HashMap<int[][],List<Board>>();
	
	
	/*** Read Input from command Line ***/
	public static void Read(String[] args) {
		
		int i = 0;
		algorithm = args[0];
		if(algorithm.equals(null)){
			System.out.println("Please Select Algorithm");
			System.exit(0);
		}
		for(String s: args) {
			if(s.equals("-m")) {
				boardSize = Integer.parseInt(args[i+1]);
			}
			if(s.equals("-n")) {
				pieceToConnect = Integer.parseInt(args[i+1]);
			}
			if(s.equals("-d")) {
				depthOfSearch = Integer.parseInt(args[i+1]);
			}
			if(s.equals("-c")) {
				gameType = false; //It is a cpu vs. cpu game
			}
			i++;
		}
		outFile = args[args.length-1];
	}
	
	/*** Write Output to specified file ***/
	public static void Write(int move) {

		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(outFile));
			if((move/2) % 2 == 0) {
				move = move/2;
			}
			else {
				move = (move/2) + 1;
			}
			out.write("Total Number of Moves: " + (move));
			out.newLine();
			for(int i=0; i<moves.size(); i++) {
				out.write("Player "+moves.get(i).player+ " Move "+moves.get(i).move+": ("+(boardSize-moves.get(i).row)+","+
						 (moves.get(i).col+1)+") - Number of nodes examined: '"+moves.get(i).numExpanded+"'");
				out.newLine();
				
			}
			out.close();
		} catch (IOException e) {
			System.out.println("Could not Write output file");
		}
		
		return;
	}
	
	/*** Simple functino that copies values of a 2 dimensional array ***/
	public static void multiArrayCopy(int[][] source,int[][] destination) {
		
		for (int a=0;a<source.length;a++)
			{
			System.arraycopy(source[a],0,destination[a],0,source[a].length);
			}
		
	}

	/*** Checks for N-connected pieces horizontally,vertically,and diagonally **/
	public static boolean Win(Board board, int player) {
		
		//Check for a horizontal victory
		for(int j=0; j<boardSize-pieceToConnect+1; j++) {
			for(int i=0; i<boardSize; i++) {
				int count = 0;
				while((count <pieceToConnect) && (board.board[i][j+count] == player)) {
					count++;
					if(count == pieceToConnect) {
						return true;
					}
				}
			}
		}
		
		
		//Check for Vertical victory
		for(int j=0; j<boardSize; j++) {
			for(int i=0; i<boardSize-pieceToConnect+1; i++) {
				int count = 0;
				while((count < pieceToConnect) && (board.board[i+count][j] == player)) {
					count++;
					if(count == pieceToConnect) {
						return true;
					}
				}
			}
		}
		
		//Check for upper diagonal victory
		for(int j=0; j<boardSize-pieceToConnect+1; j++) {
			for(int i=0; i<boardSize-pieceToConnect+1; i++) {
				int count = 0;
				while((count < pieceToConnect) && (board.board[i+count][j+count] == player)) {
					count++;
					if(count == pieceToConnect) {
						return true;
					}
				}
			}
		}
		
		//Check for lower diagonal victory
		for(int j=0; j<boardSize-pieceToConnect+1; j++) {
			for(int i=0; i<boardSize; i++) {
				int count = 0;
				while((count < pieceToConnect) && (board.board[i-count][j+count] == player)) {
					count++;
					if(count == pieceToConnect) {
						return true;
					}
					if(i-count < 0) {
						break;
					}
					if(j+count > boardSize) {
						break;
					}
				}
			}
		}
		
		return false;
	}
	
	/*** Check to see if board is full ***/
	public static boolean IsFull(Board board) {
		
		for(int i=0; i<boardSize; i++) {
			for(int j=0; j<boardSize; j++) {
				if(board.board[i][j] == 0) {
					return false;
				}
			}
		}
		return true;
	}
	
	/*** Utility function applied at CUTOFF. Applies i-out-of-N ***/
	public static int Utility(Board board) {
		
		int player = 0;

		int total_horiz = 0;
		int total_horiz2 = 0;
		int total_vert = 0;
		int total_vert2 = 0;
		int total_upper_diag = 0;
		int total_upper_diag2 = 0;
		int total_lower_diag = 0;
		int total_lower_diag2 = 0;
		
		if(IsFull(board) == true) {
			return 0;
		}
		//Implement "n-1 out of n" heuristic for Utility function
		//Check for n-1 out of n horizontally
		for(int j=0; j<boardSize-pieceToConnect+1; j++) {
			for(int i=0; i<boardSize; i++) {
				int count = 0;
				int count2 = 0;
				while((count <pieceToConnect) && (board.board[i][j+count] == 1)) {
					count++;
					if(count == pieceToConnect) {
						board.value = 10000000;
						return 10000000;
					}
					total_horiz = count;
				}
				while((count2 <pieceToConnect) && (board.board[i][j+count2] == 2)) {
					count2++;
					if(count2 == pieceToConnect) {
						board.value = -10000000;
						return -10000000;
					}
					total_horiz2 = count2;
				}
			}
		}
		
		
		//Check for number in vertical
		for(int j=0; j<boardSize; j++) {
			for(int i=0; i<boardSize-pieceToConnect+1; i++) {
				int count = 0;
				int count2 = 0;
				while((count < pieceToConnect) && (board.board[i+count][j] == 1)) {
					count++;
					if(count == pieceToConnect) {
						board.value = 10000000;
						return 10000000;
					}
					total_vert = count;
				}
				while((count2 < pieceToConnect) && (board.board[i+count2][j] == 2)) {
					count2++;
					if(count2 == pieceToConnect) {
						board.value = -10000000;
						return -10000000;
					}
					total_vert2 = count2;
				}
			}
		}
		
		//Check for number in upper diagonal
		for(int j=0; j<boardSize-pieceToConnect+1; j++) {
			for(int i=0; i<boardSize-pieceToConnect+1; i++) {
				int count = 0;
				int count2 = 0;
				while((count < pieceToConnect) && (board.board[i+count][j+count] == 1)) {
					count++;
					if(count == pieceToConnect) {
						board.value = 10000000;
						return 10000000;	
					}
					total_upper_diag = count;
				}
				while((count2 < pieceToConnect) && (board.board[i+count2][j+count2] == 2)) {
					count2++;
					if(count2 == pieceToConnect) {
						board.value = -10000000;
						return -10000000;	
					}
					total_upper_diag2 = count2;
				}
				
			}
		}
		
		//Check for number in lower diagonal
		for(int j=0; j<boardSize-pieceToConnect+1; j++) {
			for(int i=0; i<boardSize; i++) {
				int count = 0;
				int count2 = 0;
				while((count < pieceToConnect) && (board.board[i-count][j+count] == 1)) {
					count++;
					if(count == pieceToConnect) {
						board.value = 10000000;
						return 10000000;
					}
					if(i-count < 0) {
						break;
					}
					if(j+count > boardSize) {
						break;
					}
					total_lower_diag = count;
				}
				while((count2 < pieceToConnect) && (board.board[i-count2][j+count2] == 2)) {
					count2++;
					if(count2 == pieceToConnect) {
						board.value = -10000000;
						return -10000000;
					}
					if(i-count2 < 0) {
						break;
					}
					if(j+count2 > boardSize) {
						break;
					}
					total_lower_diag2 = count2;
				}
				
			}
		}
		
		//Get the total Score
		int total_1 = 0;
		int total_2 = 0;
		for(int i=0; i<pieceToConnect; i++) {
			if(total_horiz == i+1) {
				total_1 += (10^i)*(i+1);
			}
			if(total_horiz2 == i+1) {
				total_2 += (10^i)*(i+1);
			}
			if(total_vert == i+1) {
				total_1 += (10^i)*(i+1);
			}
			if(total_vert2 == i+1) {
				total_2 += (10^i)*(i+1);
			}
			if(total_upper_diag == i+1) {
				total_1 += (10^i)*(i+1);
			}
			if(total_upper_diag2 == i+1) {
				total_2 += (10^i)*(i+1);
			}
			if(total_lower_diag == i+1) {
				total_1 += (10^i)*(i+1);
			}
			if(total_lower_diag2 == i+1) {
				total_2 += (10^i)*(i+1);
			}
			
		}
	
		int difference = total_1 - total_2;
		
		board.value = difference;
		
		return difference;
	}

	/*** Adds players piece to the board at specified location ***/
	public static void AddToBoard(Board board, int col, int player, int num) {
		
		int fullFlag = -1;
		int nodesExpanded = GetNumNodesExpanded(board);
		for(int i=boardSize-1; i>-1; i--) {
			if(board.board[i][col] == 0) {
				board.board[i][col] = player;
				fullFlag = 0;
				move play = new move(player,num,col,i);
				play.numExpanded = nodesExpanded;
				moves.add(play);
				break;
			}
		}
		
		if(fullFlag == -1) {
			System.out.println("Column Full");
		}
	}
	
	/*** Expands a State of the Game Tree and Gets it's children ***/
	public static List<Board> GetSuccessors(Board board, List<Board> children, String type) {
		
		int player = 0;
		if(type.equals("max")) {
			player = 1;
		}
		else if(type.equals("min")) {
			player = 2;
		}
		
		
		//Need to go through all possible game states of current state
		for(int i=boardSize-1; i>-1; i--) {
			for(int j=boardSize-1; j>-1; j--) {
				if(board.board[i][j] == 0) {
					if(i == boardSize-1) { 					//the bottom row of the board
						int[][] child = new int[boardSize][boardSize];
						multiArrayCopy(board.board,child);
						child[i][j] = player;
						Board new_board = new Board(child,board.depth+1, type);
						children.add(new_board);
					}
					else if(board.board[i+1][j] != 0) {		//Place token on top of other piece
						int[][] child = new int[boardSize][boardSize];
						multiArrayCopy(board.board,child);
						child[i][j] = player;
						Board new_board = new Board(child,board.depth+1, type);
						children.add(new_board);
					}
				}
			}
		}
		gameTree.put(board.board, children);
		return children;
		
	}
	
	/*** Returns coordinates of piece placed by the computer player ***/
	public static void GetCoordinates(Board board1, Board board2, int numPlays,int player) {
		int nodesExpanded = GetNumNodesExpanded(board1);
		for(int i=0; i<boardSize; i++) {
			for(int j=0; j<boardSize; j++) {
				if(board1.board[i][j] != board2.board[i][j]) {
					if(!gameType) {
						board2.board[i][j] = player;
					}
					move play = new move(player,numPlays,j,i);
					play.numExpanded = nodesExpanded; 
					moves.add(play);
					return;
				}
			}
		}
		
	}
	
	/*** Begins the MinMax or Alpha-Beta Algorithm ***/
	public static Board MinimaxDecision(Board board, int play,int player) {
		
		board.alpha = -10000000;	//Default alpha value
		board.beta = 10000000;		//Default beta value
		if(algorithm.equals("alpha-beta")) {
			int v = MaxValue(board,board.alpha,board.beta);
			board.value = v;
			for(int i=0; i<gameTree.get(board.board).size(); i++) {
				if(board.value == gameTree.get(board.board).get(i).value) {
					GetCoordinates(board, gameTree.get(board.board).get(i),play,player);
					return gameTree.get(board.board).get(i);
				}
			
			}
		}
		else {
			int v = MaxValue(board,board.alpha,board.beta);
			board.value = v;
			for(int i=0; i<gameTree.get(board.board).size(); i++) {
				if(board.value == gameTree.get(board.board).get(i).value) {
					GetCoordinates(board, gameTree.get(board.board).get(i),play,player);
					return gameTree.get(board.board).get(i);
				}
			
			}
		}
		return board;
		
	}
	
	/*** Recursive MaxValue implementation ***/
	public static int MaxValue(Board board,int a, int B) {
		
		List<Board> children = new ArrayList<Board>();
		String type;
		
		type = "max";
	
		children = GetSuccessors(board,children,type);
		if(board.depth >= depthOfSearch) {
			return Utility(board);
		}
		else if(gameTree.get(board.board).isEmpty()) {
			return Utility(board);
		}
		
		board.value = -1000000;
		
		//Go through all of the children
		for(int i=0; i<children.size(); i++) {
			
			if(algorithm.equals("alpha-beta")) {
				board.value = Math.max(board.value,MinValue(children.get(i),board.alpha,board.beta));
				if(board.value >= board.beta){
					return board.value;
				}
				board.alpha = Math.max(board.alpha,board.value);
			}
			else {
				board.value = Math.max(board.value,MinValue(children.get(i),a,B));
			}
		}
		
		return board.value;
		
	}
	
	/*** Recursive MinValue Implementation ***/
	public static int MinValue(Board board,int a, int B) {
		
		String type;
		List<Board> children = new ArrayList<Board>();
		
		 type = "min";
		
		children = GetSuccessors(board,children,type);
		if(board.depth >= depthOfSearch) {
			return Utility(board);
		}
		else if(gameTree.get(board.board).isEmpty()) {
			return Utility(board);
		}
		
		board.value = 10000000;
		
		for(int i=0; i<children.size(); i++) {
			
			if(algorithm.equals("alpha-beta")) {
				board.value = Math.min(board.value, MaxValue(children.get(i),board.alpha,board.beta));
				if(board.value <= board.alpha) {
					return board.value;
				}
				board.beta = Math.min(board.value,board.beta);
			}
			else {
				board.value = Math.min(board.value, MaxValue(children.get(i),a,B));
			}
		}
		
		return board.value;
		
	}
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		
		//read input arguments
		Read(args);
		
		//Create gameboard and Initialize it to 0
		Board board = new Board(boardSize,1);
		board.max = true;

		
		InputStreamReader converter = new InputStreamReader(System.in);
		BufferedReader in = new BufferedReader(converter);
		int curLine = 0; //Move entered
		int play = 1;
		int move = 1;
		
		//loop for the game to be played
		while(true) {
			
			//Player 1 
			if(move % 2 == 1) {		
				if(gameType) {
					System.out.println("Player 1 move ");
				}
				
				//Return the decision from Minimax and make it the new board
				Board new_board;
				new_board = MinimaxDecision(board,play,1);
				multiArrayCopy(new_board.board,board.board);
				gameTree.clear();
				
				//Check to see if Player 1 won
				if(Win(board,1)) {
					System.out.println("Congratulations Player 1, you have won the Game!");
					PrintBoard(board);
					break;
				}
				if(IsFull(board)) {
					System.out.println("Draw");
					break;
				}
				board.value = 0;
				move++;
				if(gameType) {
					PrintBoard(board);
				}
					
			}
			//Player 2
			else {
				
				//Computer vs. Computer
				if(gameType == false) {
					Board new_board;
					board.min = true;
					board.max = false;
					new_board = MinimaxDecision(board,play,2);
					multiArrayCopy(new_board.board,board.board);
					gameTree.clear();
		
					//Check to see if player 2 won
					if(Win(board,2)) {
						System.out.println("Congratulations Player 2, you have won the Game!!");
						PrintBoard(board);
						break;
					}
					if(IsFull(board)) {
						System.out.println("Draw");
						break;
					}
					board.value = 0;
					move++;
				}
				else {
					System.out.println("Player 2 move ");
					System.out.print("Please select the column (0-"+(boardSize-1)+") for Move "+move+": ");
					curLine = Integer.parseInt(in.readLine());
					if(curLine < 0 || curLine > boardSize-1) {
						System.out.println("Incorrect Column number");
					}
					else {
						AddToBoard(board,curLine,2,play);
						move++;
					}
					//Check to see if player 2 won
					if(Win(board,2)) {
						System.out.println("Congratulations Player 2, you have won the Game!");
						PrintBoard(board);
						break;
					}
					if(IsFull(board)) {
						System.out.println("Draw");
						break;
					}
					PrintBoard(board);
				}
			}
			//PrintBoard(board);
			if(move % 2 != 0) {
				play++;
			}
		}
		Write(move);
	}


	private static void PrintBoard(Board board) {
	
		for(int i=0; i<boardSize; i++) {
			for(int j=0; j<boardSize; j++) {
				if(board.board[i][j] == 0) {
					System.out.print(" * ");
				}
				else if(board.board[i][j] == 1) {
					System.out.print(" R ");
				}
				else {
					System.out.print(" Y ");
				}
			}
			System.out.println();
		}
	}

	private static int GetNumNodesExpanded(Board board) {
		
		int total = 0;
		for(int[][] key : gameTree.keySet()) {
			total += gameTree.get(key).size();
		}
		
		return total;
		
	}

}
